#ifndef CRLCERROR_HH
#define CRLCERROR_HH
 
#include <iostream>
#include <exception>
/**
 * Klasa reprezentujaca wyjatek.
 */
class CRlcException
 {
   public:
   /**
    * Konstruktor.
    * @param &e komunikat opisujacy zaistnialy wyjatek.
    */   
     CRlcException(const std::string &e):m_message(e){};
   /**
    * Zwraca komunikat opisujacy zaistnialy wyjatek.
    * @return komunikat opisujacy zaistnialy wyjatek.
    */   
     std::string what(){return m_message;};
   protected:
   /** Komunikat. */   
     std::string m_message;     
 };
/**
 * Klasa reprezentuje wyjatek wystepujacy podczas konwersji.
 */
class CRlcConversionError:public CRlcException 
 {
 public :
   /**
    * Konstruktor.
    * @param &e komunikat opisujacy zaistnialy wyjatek.
    */   
   CRlcConversionError(const std::string &e="ConversionError"):CRlcException(e) {};
 };
 
#endif 
