#include <electro/CBranch.hh>
#include <electro/CVoltage.hh>
#include <electro/CCurent.hh>

void CBranch::print_branch()
{
for(int i=0;i<elements.size();i++)
    cout << "("<<elements[i]->getName()<<") ";
cout<<endl;    
//cout<<"\tZ="<<Z<<" \tU="<<U<<" \tI="<<I<<endl;    
}

bool CBranch::isCurent()
{
for(int i=0;i<elements.size();i++)
  if(dynamic_cast<CCurent *> (elements[i])) return true;
return false;
}


Complex CBranch::getZ(double omega)
{
CElementPasive *p;
Complex z(0,0);
for(int i=0;i<elements.size();i++)
  if(p=dynamic_cast<CElementPasive *> (elements[i])) 
      z = z + p->getZc(omega);
return z;
}

Complex CBranch::getU(double omega)
{
CVoltage *p;
Complex u(0,0);
for(int i=0;i<elements.size();i++)
  if(p=dynamic_cast<CVoltage *> (elements[i])) 
      if(omega==p->getOmega()) u = u + p->getUc();
return u;
}

Complex CBranch::getI(double omega)
{
CCurent *p;
Complex i(0,0);
for(int j=0;j<elements.size();j++)
  if(p=dynamic_cast<CCurent *> (elements[j])) 
      if(omega==p->getOmega()) i = i + p->getIc();
return i;
}
