#include <iostream>
#include <cmath>

#include "CCapasistor.hh"

#include <CCircuit.hh>

#include <networksarea.hh>


void CCapasistor::draw()
{  
  RLC::CNetworksArea* parentNetworksArea = m_ParentCircuit->m_ParentDrawingArea;
  Glib::RefPtr<Gdk::Pixmap> refPixmap_NetworksArea = parentNetworksArea->m_RefPixmap_NetworksArea;
  Glib::RefPtr<Gdk::GC> refGC_NetworksArea = parentNetworksArea->m_RefGC_NetworksArea;
  int squareSize = parentNetworksArea->m_SquareSize;
  int nodeSize   = parentNetworksArea->m_NodeSize;

  //TODO: change this below to not use 'case'. Figure out some simple math formula for this.
  // Setting variables based on rotatation for futher use.
  int rot_x = 0, rot_y = 0;
  switch (m_rot) {
    case  1: rot_y = 1; break;
    case  2: rot_x =-1; break;
    case  3: rot_y =-1; break;
    default: rot_x = 1; 
  }

 /* 
  refPixmap_NetworksArea->draw_rectangle(
      refGC_NetworksArea,
      0,
      (m_x+0.5*abs(rot_y))*squareSize,
      (m_y+0.5*abs(rot_x))*squareSize,
      (1+abs(rot_x))*squareSize,
      (1+abs(rot_y))*squareSize);
*/

  double coverRatio = 0.5; // Part of the a distance between capasistor cover 
                           // TODO: describe this better
			   
  double coverWidthRatio = 0.5; // Part of coverRatio that represents covers width
  
  refPixmap_NetworksArea->draw_rectangle(
      refGC_NetworksArea,
      1,
      static_cast<int>( (m_x+coverRatio*abs(rot_x))*squareSize ),
      static_cast<int>( (m_y+coverRatio*abs(rot_y))*squareSize ),
      static_cast<int>( (coverWidthRatio*coverRatio*abs(rot_x)+2*abs(rot_y))*squareSize ),
      static_cast<int>( (coverWidthRatio*coverRatio*abs(rot_y)+2*abs(rot_x))*squareSize ) );

  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      static_cast<int>( (m_x+1+rot_x*coverRatio)*squareSize ),
      static_cast<int>( (m_y+1-rot_y*coverRatio)*squareSize ),
      (m_x+1+2*rot_x)*squareSize,
      (m_y+1-2*rot_y)*squareSize);

  // refPixmap_NetworksArea->draw_arc(
      // refGC_NetworksArea,
      // 1,
      // (m_x+1+2*rot_x)*squareSize-nodeSize,
      // (m_y+1-2*rot_y)*squareSize-nodeSize,
      // 2*nodeSize,
      // 2*nodeSize,
      // 0,360*64);
   
  // TODO: draw this better. Covers are not equally far from the center. Why??
  refPixmap_NetworksArea->draw_rectangle(
      refGC_NetworksArea,
      1,
      static_cast<int>( (m_x+(2-coverRatio*(1+coverWidthRatio))*abs(rot_x))*squareSize ),
      static_cast<int>( (m_y+(2-coverRatio*(1+coverWidthRatio))*abs(rot_y))*squareSize ),
      static_cast<int>( (coverWidthRatio*coverRatio*abs(rot_x)+2*abs(rot_y))*squareSize ),
      static_cast<int>( (coverWidthRatio*coverRatio*abs(rot_y)+2*abs(rot_x))*squareSize ) );

  
  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      static_cast<int>( (m_x+1-rot_x*coverRatio)*squareSize ),
      static_cast<int>( (m_y+1+rot_y*coverRatio)*squareSize ),
      (m_x+1-2*rot_x)*squareSize,
      (m_y+1+2*rot_y)*squareSize);

  // refPixmap_NetworksArea->draw_arc(
      // refGC_NetworksArea,
      // 1,
      // (m_x+1-2*rot_x)*squareSize-nodeSize,
      // (m_y+1+2*rot_y)*squareSize-nodeSize,
      // 2*nodeSize,
      // 2*nodeSize,
      // 0,360*64);

  //std::cout << "CCapasistor::draw() called" << std::endl;
}

