#include <iostream>
#include <cmath>

#include "CCurent_u.hh"
#include <CCircuit.hh>
#include <networksarea.hh>


void CCurent_u::draw()
{
  RLC::CNetworksArea* parentNetworksArea = m_ParentCircuit->m_ParentDrawingArea;
  Glib::RefPtr<Gdk::Pixmap> refPixmap_NetworksArea = parentNetworksArea->m_RefPixmap_NetworksArea;
  Glib::RefPtr<Gdk::GC> refGC_NetworksArea = parentNetworksArea->m_RefGC_NetworksArea;
  int squareSize = parentNetworksArea->m_SquareSize;
  int nodeSize   = parentNetworksArea->m_NodeSize;

  //TODO: change this below to not use 'case'. Figure out some simple math formula for this.
  // Setting variables based on rotatation for futher use.
  int rot_x = 0, rot_y = 0;
  switch (m_rot) {
    case  1: rot_y = 1; break;
    case  2: rot_x =-1; break;
    case  3: rot_y =-1; break;
    default: rot_x = 1; 
  }

  double diagRatio = 0.75; // This tells what part of a squareSize is being taken, as a half
                           // of shorter diagonal in our diamond we draw here.
  

  // TODO: do this on Point object and ArrayHanlder from Glib.			   
  // Drawing outer diamond.
  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      (m_x+abs(rot_y))*squareSize,
      (m_y+abs(rot_x))*squareSize,
      static_cast<int>( (m_x+abs(rot_x)+abs(rot_y)*(1+diagRatio))*squareSize ),
      static_cast<int>( (m_y+abs(rot_y)+abs(rot_x)*(1+diagRatio))*squareSize ) );

  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      (m_x+abs(rot_y))*squareSize,
      (m_y+abs(rot_x))*squareSize,
      static_cast<int>( (m_x+abs(rot_x)+abs(rot_y)*(1-diagRatio))*squareSize ),
      static_cast<int>( (m_y+abs(rot_y)+abs(rot_x)*(1-diagRatio))*squareSize ) );

  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      (m_x+abs(rot_y)+2*abs(rot_x))*squareSize,
      (m_y+abs(rot_x)+2*abs(rot_y))*squareSize,
      static_cast<int>( (m_x+abs(rot_x)+abs(rot_y)*(1+diagRatio))*squareSize ),
      static_cast<int>( (m_y+abs(rot_y)+abs(rot_x)*(1+diagRatio))*squareSize ) );

  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      (m_x+abs(rot_y)+2*abs(rot_x))*squareSize,
      (m_y+abs(rot_x)+2*abs(rot_y))*squareSize,
      static_cast<int>( (m_x+abs(rot_x)+abs(rot_y)*(1-diagRatio))*squareSize ),
      static_cast<int>( (m_y+abs(rot_y)+abs(rot_x)*(1-diagRatio))*squareSize ) );


  double innerDiamRatio = 0.3; // This tells what part of a squareSize is used as a space
                               // between inner and outer diamond.
  
  // TODO: it seems like this inner diamond is not drawn symetrically. Why?!  
  // Draw inner diamond.
  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      static_cast<int>( (m_x+abs(rot_y)+innerDiamRatio*abs(rot_x))*squareSize ),
      static_cast<int>( (m_y+abs(rot_x)+innerDiamRatio*abs(rot_y))*squareSize ),
      static_cast<int>( (m_x+abs(rot_x)+abs(rot_y)*(1+diagRatio*(1-innerDiamRatio)))*squareSize ),
      static_cast<int>( (m_y+abs(rot_y)+abs(rot_x)*(1+diagRatio*(1-innerDiamRatio)))*squareSize ) );

  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      static_cast<int>( (m_x+abs(rot_y)+innerDiamRatio*abs(rot_x))*squareSize ),
      static_cast<int>( (m_y+abs(rot_x)+innerDiamRatio*abs(rot_y))*squareSize ),
      static_cast<int>( (m_x+abs(rot_x)+abs(rot_y)*(1-diagRatio*(1-innerDiamRatio)))*squareSize ),
      static_cast<int>( (m_y+abs(rot_y)+abs(rot_x)*(1-diagRatio*(1-innerDiamRatio)))*squareSize ) );

  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      static_cast<int>( (m_x+abs(rot_y)+2*abs(rot_x)-innerDiamRatio*abs(rot_x))*squareSize ),
      static_cast<int>( (m_y+abs(rot_x)+2*abs(rot_y)-innerDiamRatio*abs(rot_y))*squareSize ),
      static_cast<int>( (m_x+abs(rot_x)+abs(rot_y)*(1+diagRatio*(1-innerDiamRatio)))*squareSize ),
      static_cast<int>( (m_y+abs(rot_y)+abs(rot_x)*(1+diagRatio*(1-innerDiamRatio)))*squareSize ) );

  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      static_cast<int>( (m_x+abs(rot_y)+2*abs(rot_x)-innerDiamRatio*abs(rot_x))*squareSize ),
      static_cast<int>( (m_y+abs(rot_x)+2*abs(rot_y)-innerDiamRatio*abs(rot_y))*squareSize ),
      static_cast<int>( (m_x+abs(rot_x)+abs(rot_y)*(1-diagRatio*(1-innerDiamRatio)))*squareSize ),
      static_cast<int>( (m_y+abs(rot_y)+abs(rot_x)*(1-diagRatio*(1-innerDiamRatio)))*squareSize ) );
   

  // Drawing element nodes and branch that lead to them. 
  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      (m_x+1+rot_x)*squareSize,
      (m_y+1-rot_y)*squareSize,
      (m_x+1+2*rot_x)*squareSize,
      (m_y+1-2*rot_y)*squareSize);

  // refPixmap_NetworksArea->draw_arc(
      // refGC_NetworksArea,
      // 1,
      // (m_x+1+2*rot_x)*squareSize-nodeSize,
      // (m_y+1-2*rot_y)*squareSize-nodeSize,
      // 2*nodeSize,
      // 2*nodeSize,
      // 0,360*64);
   
  refPixmap_NetworksArea->draw_line(
      refGC_NetworksArea,
      (m_x+1-rot_x)*squareSize,
      (m_y+1+rot_y)*squareSize,
      (m_x+1-2*rot_x)*squareSize,
      (m_y+1+2*rot_y)*squareSize);

  // refPixmap_NetworksArea->draw_arc(
      // refGC_NetworksArea,
      // 1,
      // (m_x+1-2*rot_x)*squareSize-nodeSize,
      // (m_y+1+2*rot_y)*squareSize-nodeSize,
      // 2*nodeSize,
      // 2*nodeSize,
      // 0,360*64);

  parentNetworksArea->mf_drawArrow(m_x, m_y, m_rot, 0.3);

  //std::cout << "CCurent_u:draw() called" << std::endl;

}



