#ifndef CVoltage_i_HH
#define CVoltage_i_HH

#include <electro/CElement.hh>
#include <vector>
/**
 * Klasa reprezentuje idealne zrodlo napieciowe sterowane pradem.
 */
class CVoltage_i : public CElementControl
{
public:
   /**
    * Konstruktor.
    * @param name nazwa .
    * @param gm wspulczynnik wzmocnienia.
    * @param on nazwa elementu pasywnego przez ktory przeplywa wzorcowy prad.
    * @param x rzedna elementu na schemacie.
    * @param y odcieta elementu na schemacie.
    * @param rot rotacja elementu na schemacie.
    * @see ~CVoltage_i();CElementControl();
    */
    CVoltage_i(std::string name,float gm,std::string on,int x=0,int y=0,int rot=0) : CElementControl("VOL_U",name,gm,on,x,y,rot){
         for(int i=0;i<2;i++)
            pins.push_back(new CPin());
	 m_valueSymbol="I";
    } 
   /**
    * Destruktor.
    * @see CVoltage_i;
    */     
    ~CVoltage_i() {}
    
    void draw();
   
    // TODO: change these functions to one that returns Glib::Point.
    int getPinX(int pinNumber);
    int getPinY(int pinNumber);
};
#endif

