#ifndef CVoltage_u_HH
#define CVoltage_u_HH

#include <electro/CElement.hh>
#include <vector>
/**
 * Klasa reprezentuje idealne zrodlo napieciowe sterowane napieciem.
 */
class CVoltage_u : public CElementControl
{
public:
   /**
    * Konstruktor.
    * @param name nazwa .
    * @param gm wspulczynnik wzmocnienia.
    * @param on nazwa wierzcholka na krorym panuje wzorcowe napiecie.
    * @param x rzedna elementu na schemacie.
    * @param y odcieta elementu na schemacie.
    * @param rot rotacja elementu na schemacie.
    * @see ~CVoltage_u();CElementControl();
    */
    CVoltage_u(std::string name,float gm,std::string on,int x=0,int y=0,int rot=0) : CElementControl("VOL_U",name,gm,on,x,y,rot){
         for(int i=0;i<2;i++)
            pins.push_back(new CPin());
	 m_valueSymbol="U";
    } 
   /**
    * Destruktor.
    * @see CVoltage_u;
    */      
    ~CVoltage_u() {}
    
    void draw();

    // TODO: change these functions to one that returns Glib::Point.
    int getPinX(int pinNumber);
    int getPinY(int pinNumber);
};
#endif
