#include <iostream>
#include <iomanip>

#include <CCircuit.hh>
#include <CCircuitSolver.hh>
#include <CRlcException.hh>


int main(int argc, char *argv[])
{
 using namespace std;
 cout << setprecision(4);
 
 CCircuit doc; 
 CCircuitSolver rozwalacz(NULL);
 
 std::string name="../../tests/test3.xml";
 if(argv[1])
   name=argv[1];

 try{
   doc.load(name);
   rozwalacz.load(&doc);
   
   rozwalacz.solve();
   
   rozwalacz.clear();
   doc.clear();
 }
 catch( CRlcException & e){
    cerr << e.what() << endl;
    exit(1);
    }
 catch( std::exception& e){
    cerr << e.what() << endl;
    exit(1);}

 return 0;
}

