#include <xml/Streamer.hh>
#include <stdexcept>		
		
using namespace std;		
using namespace XML;		
		
void Streamer::closeTag(bool inIndent)		
{		
	if(mTags.empty()) throw runtime_error("<Writer::closeTag> No tag to close!");	
	if(!mClosed) mStream << "/>" << endl;	
	else	
	{	
	// indentation depends on the number of tags currently on the stack.	
	unsigned int lIndent = mWidth*(mTags.size()-1);	
	if(inIndent && lIndent) mStream << string(lIndent, ' ');
	
	
	mStream << "</" << mTags.top() << ">" << endl;	
	}	
	mClosed = true;	
	mTags.pop();	
}		
		
ostream& Streamer::getStream()		
{		
    return mStream;		
}		
		
void Streamer::insertAttribute		
(const string& inName,double inValue)	
{		
	mStream << " " << inName << "=\"" << inValue << "\"";	
}		
		
void Streamer::insertAttribute		
(const string& inName,string inValue)	
{		
mStream << " " << inName << "=\"" << inValue << "\"";	
}		
		
void Streamer::insertPrimitiveTag		
(		
double inValue,	
const string& inTagName,		
const string& inAttName		
)		
{		
openTag(inTagName);		
insertAttribute(inAttName, inValue);		
closeTag(false);		
}		
		
void Streamer::insertPrimitiveTag		
(		
int inValue,		
const string& inTagName,		
const string& inAttName		
)		
{		
openTag(inTagName);		
insertAttribute(inAttName, inValue);		
closeTag(false);		
}		
		
void Streamer::insertPrimitiveTag		
(		
const string& inValue,		
const string& inTagName,		
const string& inAttName		
)		
{		
openTag(inTagName);		
insertAttribute(inAttName, inValue);		
closeTag(false);		
}		
		
void Streamer::insertSpecialTag(const std::string& inTag)		
{		
if(!mClosed) {		
mStream << ">" << endl;		
mClosed = true;		
}		
// indentation depends on the number of tags currently on the stack.		
unsigned int lIndent = mWidth*mTags.size();		
if(lIndent) mStream << string(lIndent, ' ');

mStream << "<" << inTag << ">" << endl;		
}		
		
void Streamer::openTag(const string& inName, bool inIndent)		
{		
if(!mClosed)		
{		
mStream << ">" << endl;		
mClosed = true;		
}		
// indentation depends on the number of tags currently on the stack.		
unsigned int lIndent = mWidth*mTags.size();		
if(inIndent && lIndent) mStream << string(lIndent, ' ');

mStream << "<" << inName;		
mTags.push(inName);		
mClosed = false;		
}		
		
Streamer& Streamer::operator<<(double inValue)		
{		
insertPrimitiveTag(inValue);		
return *this;		
}		
		
Streamer& Streamer::operator<<(int inValue)		
{		
insertPrimitiveTag(inValue);		
return *this;		
}		
		
Streamer& Streamer::operator<<(const string& inValue)		
{		
insertPrimitiveTag(inValue);		
return *this;		
}		

