/*
 * RolLerCoaster Linear Networks Solver
 *
 * RolLerCoaster is the legal property of its developers, whose names are 
 * listed in the COPYRIGHT file distributed with this source distribution.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the free software foundation; either version 2 of the license, or
 * (at your option) any later version.
 *
 * this program is distributed in the hope that it will be useful,
 * but without any warranty; without even the implied warranty of
 * merchantability or fitness for a particular purpose.  see the
 * gnu general public license for more details.
 *
 * you should have received a copy of the gnu general public license
 * along with this program; if not, write to the free software
 * foundation, inc., 59 temple place, suite 330, boston, ma  02111-1307  usa
 *
 */


#include <gtkmm/stock.h>
#include <gtkmm/separatortoolitem.h>

#include "mainwindow.hh"
#include "maintoolbar.hh"
#include "networksarea.hh"

using namespace RLC;


CMainToolbar::CMainToolbar()
{

  /*
   * Adding items (buttons & separators) to toolbar and connecting clicked signal
   * handlers to them.
   */
  {

    Gtk::ToolButton* toolbarItem;
    // "New" button
    // Gtk::ToolButton* toolbarItem = Gtk::manage( new Gtk::ToolButton(Gtk::Stock::NEW) );
    // append(*toolbarItem);
    // toolbarItem->signal_clicked().connect( sigc::mem_fun(*this, 
	  // &CMainToolbar::on_toolbar_button_new) );

    // "Open" button
    toolbarItem = Gtk::manage( new Gtk::ToolButton(Gtk::Stock::OPEN) );
    append(*toolbarItem);
    toolbarItem->signal_clicked().connect( sigc::mem_fun(*this, 
	  &CMainToolbar::on_toolbar_button_open) );

    // Separator
    append( *(Gtk::manage(new Gtk::SeparatorToolItem)) );
    
    // "Solve" button
    // toolbarItem = Gtk::manage( new Gtk::ToolButton("Solve"));
    // TODO: Using "execute" stock item for a while - change this to your own
    // "solve" button.
    toolbarItem = Gtk::manage( new Gtk::ToolButton(Gtk::Stock::EXECUTE) );
    append(*toolbarItem);
    toolbarItem->signal_clicked().connect( sigc::mem_fun(*this, 
	  &CMainToolbar::on_toolbar_button_solve) );
  }
  
 // Parent pointer initialization
 m_parent = 0;
}


CMainToolbar::~CMainToolbar()
{

}


void CMainToolbar::on_toolbar_button_new()
{

}


void CMainToolbar::on_toolbar_button_open()
{
  m_parent->m_NetworksArea_Main.openCircuitFile();
}


void CMainToolbar::on_toolbar_button_solve()
{
  m_parent->m_NetworksArea_Main.solveCircuit();
}


void CMainToolbar::setParent(CMainWindow* parent)
{
  m_parent =  parent;
}

