/*
 * RolLerCoaster Linear Networks Solver
 *
 * RolLerCoaster is the legal property of its developers, whose names are 
 * listed in the COPYRIGHT file distributed with this source distribution.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the free software foundation; either version 2 of the license, or
 * (at your option) any later version.
 *
 * this program is distributed in the hope that it will be useful,
 * but without any warranty; without even the implied warranty of
 * merchantability or fitness for a particular purpose.  see the
 * gnu general public license for more details.
 *
 * you should have received a copy of the gnu general public license
 * along with this program; if not, write to the free software
 * foundation, inc., 59 temple place, suite 330, boston, ma  02111-1307  usa
 *
 */
 
#ifndef MAINTOOLBAR_HH
#define MAINTOOLBAR_HH

#include <gtkmm/toolbar.h>


/**
 * Main RolLerCoaster namespace.
 * Namespace that consists of every class that is made for R(ol)L(er)C(oaster).
 */
namespace RLC
{
  class CMainWindow;

  /**
   * A upper toolbar class.
   */
  class CMainToolbar : public Gtk::Toolbar
  {
    public:
      CMainToolbar();
      ~CMainToolbar();

      /**
       * A method used for setting a parent CMainWindow class pointer.
       * This is so that for this class we could get "upper" and use
       * public methods of others widgets in a window.
       * @param parent pointer to parent window
       * @see m_parent
       */
      void setParent(RLC::CMainWindow* parent);
      
    protected:
      void on_toolbar_button_new();
      void on_toolbar_button_open();
      void on_toolbar_button_solve();

      /**
       * A pointer to a CMainWindow object that this object is inside.
       * @see setParent
       */
      RLC::CMainWindow* m_parent;
  };
  
}


#endif // MAINTOOLBAR_HH

