#ifndef SIGNALFRAME_HH
#define SIGNALFRAME_HH

#include <gdkmm/types.h>
#include <electro/CSignal.hh>

namespace RLC {
  class CNetworksArea;

  /**
   * A class that represents signal frame.
   * This frame is what is drawn on the screen, it inludes signal chart.
   */
  class CSignalFrame
  {
    public:
      CSignalFrame();
      ~CSignalFrame(){}

      /**
       * Connect a frame with a signal.
       */
      void setSignal(CSignal* signal) {m_signal = signal;}
      /**
       * Sets coords (pixel coords, not field coords).
       */
      void setCoords(Gdk::Point coords);
      /**
       * Sets size of a frame in pixels.
       */
      void setSize(Gdk::Point size) {m_size = size;}
      /**
       * Sets a NetworksArea where signal frame will be drawn.
       */
      void setParent(RLC::CNetworksArea* parent) {m_parent = parent;}
      /**
       * Draws signal frame.
       */
      void draw();

    protected:
      int xF(int x);
      int yF(int y);
      int xC(int x);
      int yC(int y);
      void resetChartCoords();
      
      CSignal* m_signal;  
      Gdk::Point m_coords;
      Gdk::Point m_size;
      Gdk::Point m_chartCoords;
      RLC::CNetworksArea* m_parent;
  };

}
#endif
